/*
*****************************************************************************
**                                                                          *
**                         COPYRIGHT (c) 1999 BY                            *
**             DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASS.                *
**                          ALL RIGHTS RESERVED                             *
**                                                                          *
**  THIS SOFTWARE IS FURNISHED UNDER A LICENSE AND MAY BE USED AND  COPIED  *
**  ONLY  IN  ACCORDANCE  WITH  THE  TERMS  OF  SUCH  LICENSE AND WITH THE  *
**  INCLUSION OF THE ABOVE COPYRIGHT NOTICE.  THIS SOFTWARE OR  ANY  OTHER  *
**  COPIES  THEREOF MAY NOT BE PROVIDED OR OTHERWISE MADE AVAILABLE TO ANY  *
**  OTHER PERSON.  NO TITLE TO AND OWNERSHIP OF  THE  SOFTWARE  IS  HEREBY  *
**  TRANSFERRED.                                                            *
**                                                                          *
**  THE INFORMATION IN THIS SOFTWARE IS SUBJECT TO CHANGE  WITHOUT  NOTICE  *
**  AND  SHOULD  NOT  BE  CONSTRUED  AS  A COMMITMENT BY DIGITAL EQUIPMENT  *
**  CORPORATION.                                                            *
**                                                                          *
**  DIGITAL ASSUMES NO RESPONSIBILITY FOR THE USE OR  RELIABILITY  OF  ITS  *
**  SOFTWARE ON EQUIPMENT WHICH IS NOT SUPPLIED BY DIGITAL.                 *
**                                                                          *
*****************************************************************************
**++
**  PRODUCT:
***
**	Compaq C++ Demangler
**
**  FILE:  
**
**      libiberty.c
**
**  ABSTRACT:
**
**	Wrapper for Compaq C++ demangler to allow it to be called from
**      GNU libiberty.
**
**  ENVIRONMENT:
**
**	User Mode
**
**  AUTHORS:
**
** 	Kenneth Block (C++ Compiler Team)
**
**  MODIFICATION HISTORY:
**
**  14-Oct-1999 Kenneth Block
**	Initial version
**
**--
**/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "demangle.h"

/* demangle a string in ds. If ds is not large enough, the buffer will be
   resized. opts are the same as for MLD_demangle_string. */
static void demangle_string(const char *s, char **ds, int *ds_len, int opts)
{
  int status;
  while (1) {
    status = MLD_demangle_string(s,*ds,*ds_len,opts);
    if (status!=MLD_INADEQUATE_ARRAY_SIZE) break;

    *ds_len = *ds_len*2 + 1000;
    *ds = (char*)realloc(*ds, *ds_len);
  }
}

char *libiberty_demangle_string(const char *mangled, int options)
{
  int len = strlen(mangled)+10;
  char *demangled = (char*)malloc(len);

#if 0
  printf("Demangle %s\n",mangled);
#endif
  demangle_string(mangled,&demangled,&len,MLD_SHOW_DEMANGLED_NAME);

  return demangled;
}
